/**
 *    Copyright (C) 2015 MongoDB Inc.
 *
 *    This program is free software: you can redistribute it and/or  modify
 *    it under the terms of the GNU Affero General Public License, version 3,
 *    as published by the Free Software Foundation.
 *
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU Affero General Public License for more details.
 *
 *    You should have received a copy of the GNU Affero General Public License
 *    along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 *    As a special exception, the copyright holders give permission to link the
 *    code of portions of this program with the OpenSSL library under certain
 *    conditions as described in each individual source file and distribute
 *    linked combinations including the program with the OpenSSL library. You
 *    must comply with the GNU Affero General Public License in all respects for
 *    all of the code used other than as permitted herein. If you modify file(s)
 *    with this exception, you may extend this exception to your version of the
 *    file(s), but you are not obligated to do so. If you do not wish to do so,
 *    delete this exception statement from your version. If you delete this
 *    exception statement from all source files in the program, then also delete
 *    it in the license file.
 *
 *    THIS IS A GENERATED FILE, DO NOT MODIFY.
 */

#include "mongo/db/fts/unicode/codepoints.h"

namespace mongo {
namespace unicode {

static const bool englishAsciiDelimiters[128] = {
    0, // 0x0
    0, // 0x1
    0, // 0x2
    0, // 0x3
    0, // 0x4
    0, // 0x5
    0, // 0x6
    0, // 0x7
    0, // 0x8
    1, // 0x9
    1, // 0xa
    1, // 0xb
    1, // 0xc
    1, // 0xd
    0, // 0xe
    0, // 0xf
    0, // 0x10
    0, // 0x11
    0, // 0x12
    0, // 0x13
    0, // 0x14
    0, // 0x15
    0, // 0x16
    0, // 0x17
    0, // 0x18
    0, // 0x19
    0, // 0x1a
    0, // 0x1b
    0, // 0x1c
    0, // 0x1d
    0, // 0x1e
    0, // 0x1f
    1, // 0x20
    1, // 0x21
    1, // 0x22
    1, // 0x23
    1, // 0x24
    1, // 0x25
    1, // 0x26
    0, // ' special case
    1, // 0x28
    1, // 0x29
    1, // 0x2a
    1, // 0x2b
    1, // 0x2c
    1, // 0x2d
    1, // 0x2e
    1, // 0x2f
    0, // 0x30
    0, // 0x31
    0, // 0x32
    0, // 0x33
    0, // 0x34
    0, // 0x35
    0, // 0x36
    0, // 0x37
    0, // 0x38
    0, // 0x39
    1, // 0x3a
    1, // 0x3b
    1, // 0x3c
    1, // 0x3d
    1, // 0x3e
    1, // 0x3f
    1, // 0x40
    0, // 0x41
    0, // 0x42
    0, // 0x43
    0, // 0x44
    0, // 0x45
    0, // 0x46
    0, // 0x47
    0, // 0x48
    0, // 0x49
    0, // 0x4a
    0, // 0x4b
    0, // 0x4c
    0, // 0x4d
    0, // 0x4e
    0, // 0x4f
    0, // 0x50
    0, // 0x51
    0, // 0x52
    0, // 0x53
    0, // 0x54
    0, // 0x55
    0, // 0x56
    0, // 0x57
    0, // 0x58
    0, // 0x59
    0, // 0x5a
    1, // 0x5b
    1, // 0x5c
    1, // 0x5d
    1, // 0x5e
    0, // 0x5f
    1, // 0x60
    0, // 0x61
    0, // 0x62
    0, // 0x63
    0, // 0x64
    0, // 0x65
    0, // 0x66
    0, // 0x67
    0, // 0x68
    0, // 0x69
    0, // 0x6a
    0, // 0x6b
    0, // 0x6c
    0, // 0x6d
    0, // 0x6e
    0, // 0x6f
    0, // 0x70
    0, // 0x71
    0, // 0x72
    0, // 0x73
    0, // 0x74
    0, // 0x75
    0, // 0x76
    0, // 0x77
    0, // 0x78
    0, // 0x79
    0, // 0x7a
    1, // 0x7b
    1, // 0x7c
    1, // 0x7d
    1, // 0x7e
    0, // 0x7f
};
static const bool nonEnglishAsciiDelimiters[128] = {
    0, // 0x0
    0, // 0x1
    0, // 0x2
    0, // 0x3
    0, // 0x4
    0, // 0x5
    0, // 0x6
    0, // 0x7
    0, // 0x8
    1, // 0x9
    1, // 0xa
    1, // 0xb
    1, // 0xc
    1, // 0xd
    0, // 0xe
    0, // 0xf
    0, // 0x10
    0, // 0x11
    0, // 0x12
    0, // 0x13
    0, // 0x14
    0, // 0x15
    0, // 0x16
    0, // 0x17
    0, // 0x18
    0, // 0x19
    0, // 0x1a
    0, // 0x1b
    0, // 0x1c
    0, // 0x1d
    0, // 0x1e
    0, // 0x1f
    1, // 0x20
    1, // 0x21
    1, // 0x22
    1, // 0x23
    1, // 0x24
    1, // 0x25
    1, // 0x26
    1, // 0x27
    1, // 0x28
    1, // 0x29
    1, // 0x2a
    1, // 0x2b
    1, // 0x2c
    1, // 0x2d
    1, // 0x2e
    1, // 0x2f
    0, // 0x30
    0, // 0x31
    0, // 0x32
    0, // 0x33
    0, // 0x34
    0, // 0x35
    0, // 0x36
    0, // 0x37
    0, // 0x38
    0, // 0x39
    1, // 0x3a
    1, // 0x3b
    1, // 0x3c
    1, // 0x3d
    1, // 0x3e
    1, // 0x3f
    1, // 0x40
    0, // 0x41
    0, // 0x42
    0, // 0x43
    0, // 0x44
    0, // 0x45
    0, // 0x46
    0, // 0x47
    0, // 0x48
    0, // 0x49
    0, // 0x4a
    0, // 0x4b
    0, // 0x4c
    0, // 0x4d
    0, // 0x4e
    0, // 0x4f
    0, // 0x50
    0, // 0x51
    0, // 0x52
    0, // 0x53
    0, // 0x54
    0, // 0x55
    0, // 0x56
    0, // 0x57
    0, // 0x58
    0, // 0x59
    0, // 0x5a
    1, // 0x5b
    1, // 0x5c
    1, // 0x5d
    1, // 0x5e
    0, // 0x5f
    1, // 0x60
    0, // 0x61
    0, // 0x62
    0, // 0x63
    0, // 0x64
    0, // 0x65
    0, // 0x66
    0, // 0x67
    0, // 0x68
    0, // 0x69
    0, // 0x6a
    0, // 0x6b
    0, // 0x6c
    0, // 0x6d
    0, // 0x6e
    0, // 0x6f
    0, // 0x70
    0, // 0x71
    0, // 0x72
    0, // 0x73
    0, // 0x74
    0, // 0x75
    0, // 0x76
    0, // 0x77
    0, // 0x78
    0, // 0x79
    0, // 0x7a
    1, // 0x7b
    1, // 0x7c
    1, // 0x7d
    1, // 0x7e
    0, // 0x7f
};
bool codepointIsDelimiter(char32_t codepoint, DelimiterListLanguage lang) {
    if (codepoint <= 0x7f) {
        if (lang == DelimiterListLanguage::kEnglish) {
            return englishAsciiDelimiters[codepoint];
        }
        return nonEnglishAsciiDelimiters[codepoint];
    }

    switch (codepoint) {
    case 0x85: return true;
    case 0xa0: return true;
    case 0xa1: return true;
    case 0xa2: return true;
    case 0xa3: return true;
    case 0xa4: return true;
    case 0xa5: return true;
    case 0xa6: return true;
    case 0xa7: return true;
    case 0xa9: return true;
    case 0xab: return true;
    case 0xac: return true;
    case 0xad: return true;
    case 0xae: return true;
    case 0xb0: return true;
    case 0xb1: return true;
    case 0xb6: return true;
    case 0xbb: return true;
    case 0xbf: return true;
    case 0xd7: return true;
    case 0xf7: return true;
    case 0x37e: return true;
    case 0x387: return true;
    case 0x589: return true;
    case 0x58a: return true;
    case 0x5be: return true;
    case 0x5c3: return true;
    case 0x60c: return true;
    case 0x61b: return true;
    case 0x61f: return true;
    case 0x6d4: return true;
    case 0x700: return true;
    case 0x701: return true;
    case 0x702: return true;
    case 0x703: return true;
    case 0x704: return true;
    case 0x705: return true;
    case 0x706: return true;
    case 0x707: return true;
    case 0x708: return true;
    case 0x709: return true;
    case 0x70a: return true;
    case 0x70c: return true;
    case 0x7f8: return true;
    case 0x7f9: return true;
    case 0x830: return true;
    case 0x831: return true;
    case 0x832: return true;
    case 0x833: return true;
    case 0x834: return true;
    case 0x835: return true;
    case 0x836: return true;
    case 0x837: return true;
    case 0x838: return true;
    case 0x839: return true;
    case 0x83a: return true;
    case 0x83b: return true;
    case 0x83c: return true;
    case 0x83d: return true;
    case 0x83e: return true;
    case 0x85e: return true;
    case 0x964: return true;
    case 0x965: return true;
    case 0xe5a: return true;
    case 0xe5b: return true;
    case 0xf08: return true;
    case 0xf0d: return true;
    case 0xf0e: return true;
    case 0xf0f: return true;
    case 0xf10: return true;
    case 0xf11: return true;
    case 0xf12: return true;
    case 0x104a: return true;
    case 0x104b: return true;
    case 0x1361: return true;
    case 0x1362: return true;
    case 0x1363: return true;
    case 0x1364: return true;
    case 0x1365: return true;
    case 0x1366: return true;
    case 0x1367: return true;
    case 0x1368: return true;
    case 0x1400: return true;
    case 0x166d: return true;
    case 0x166e: return true;
    case 0x1680: return true;
    case 0x16eb: return true;
    case 0x16ec: return true;
    case 0x16ed: return true;
    case 0x1735: return true;
    case 0x1736: return true;
    case 0x17d4: return true;
    case 0x17d5: return true;
    case 0x17d6: return true;
    case 0x17da: return true;
    case 0x1802: return true;
    case 0x1803: return true;
    case 0x1804: return true;
    case 0x1805: return true;
    case 0x1806: return true;
    case 0x1808: return true;
    case 0x1809: return true;
    case 0x1944: return true;
    case 0x1945: return true;
    case 0x1aa8: return true;
    case 0x1aa9: return true;
    case 0x1aaa: return true;
    case 0x1aab: return true;
    case 0x1b5a: return true;
    case 0x1b5b: return true;
    case 0x1b5d: return true;
    case 0x1b5e: return true;
    case 0x1b5f: return true;
    case 0x1c3b: return true;
    case 0x1c3c: return true;
    case 0x1c3d: return true;
    case 0x1c3e: return true;
    case 0x1c3f: return true;
    case 0x1c7e: return true;
    case 0x1c7f: return true;
    case 0x2000: return true;
    case 0x2001: return true;
    case 0x2002: return true;
    case 0x2003: return true;
    case 0x2004: return true;
    case 0x2005: return true;
    case 0x2006: return true;
    case 0x2007: return true;
    case 0x2008: return true;
    case 0x2009: return true;
    case 0x200a: return true;
    case 0x2010: return true;
    case 0x2011: return true;
    case 0x2012: return true;
    case 0x2013: return true;
    case 0x2014: return true;
    case 0x2015: return true;
    case 0x2016: return true;
    case 0x2017: return true;
    case 0x2018: return true;
    case 0x2019: return true;
    case 0x201a: return true;
    case 0x201b: return true;
    case 0x201c: return true;
    case 0x201d: return true;
    case 0x201e: return true;
    case 0x201f: return true;
    case 0x2020: return true;
    case 0x2021: return true;
    case 0x2022: return true;
    case 0x2023: return true;
    case 0x2024: return true;
    case 0x2025: return true;
    case 0x2026: return true;
    case 0x2027: return true;
    case 0x2028: return true;
    case 0x2029: return true;
    case 0x202f: return true;
    case 0x2030: return true;
    case 0x2031: return true;
    case 0x2032: return true;
    case 0x2033: return true;
    case 0x2034: return true;
    case 0x2035: return true;
    case 0x2036: return true;
    case 0x2037: return true;
    case 0x2038: return true;
    case 0x2039: return true;
    case 0x203a: return true;
    case 0x203b: return true;
    case 0x203c: return true;
    case 0x203d: return true;
    case 0x203e: return true;
    case 0x2041: return true;
    case 0x2042: return true;
    case 0x2043: return true;
    case 0x2044: return true;
    case 0x2045: return true;
    case 0x2046: return true;
    case 0x2047: return true;
    case 0x2048: return true;
    case 0x2049: return true;
    case 0x204a: return true;
    case 0x204b: return true;
    case 0x204c: return true;
    case 0x204d: return true;
    case 0x204e: return true;
    case 0x204f: return true;
    case 0x2050: return true;
    case 0x2051: return true;
    case 0x2052: return true;
    case 0x2053: return true;
    case 0x2055: return true;
    case 0x2056: return true;
    case 0x2057: return true;
    case 0x2058: return true;
    case 0x2059: return true;
    case 0x205a: return true;
    case 0x205b: return true;
    case 0x205c: return true;
    case 0x205d: return true;
    case 0x205e: return true;
    case 0x205f: return true;
    case 0x207b: return true;
    case 0x208b: return true;
    case 0x2190: return true;
    case 0x2191: return true;
    case 0x2192: return true;
    case 0x2193: return true;
    case 0x2194: return true;
    case 0x2195: return true;
    case 0x2196: return true;
    case 0x2197: return true;
    case 0x2198: return true;
    case 0x2199: return true;
    case 0x219a: return true;
    case 0x219b: return true;
    case 0x219c: return true;
    case 0x219d: return true;
    case 0x219e: return true;
    case 0x219f: return true;
    case 0x21a0: return true;
    case 0x21a1: return true;
    case 0x21a2: return true;
    case 0x21a3: return true;
    case 0x21a4: return true;
    case 0x21a5: return true;
    case 0x21a6: return true;
    case 0x21a7: return true;
    case 0x21a8: return true;
    case 0x21a9: return true;
    case 0x21aa: return true;
    case 0x21ab: return true;
    case 0x21ac: return true;
    case 0x21ad: return true;
    case 0x21ae: return true;
    case 0x21af: return true;
    case 0x21b0: return true;
    case 0x21b1: return true;
    case 0x21b2: return true;
    case 0x21b3: return true;
    case 0x21b4: return true;
    case 0x21b5: return true;
    case 0x21b6: return true;
    case 0x21b7: return true;
    case 0x21b8: return true;
    case 0x21b9: return true;
    case 0x21ba: return true;
    case 0x21bb: return true;
    case 0x21bc: return true;
    case 0x21bd: return true;
    case 0x21be: return true;
    case 0x21bf: return true;
    case 0x21c0: return true;
    case 0x21c1: return true;
    case 0x21c2: return true;
    case 0x21c3: return true;
    case 0x21c4: return true;
    case 0x21c5: return true;
    case 0x21c6: return true;
    case 0x21c7: return true;
    case 0x21c8: return true;
    case 0x21c9: return true;
    case 0x21ca: return true;
    case 0x21cb: return true;
    case 0x21cc: return true;
    case 0x21cd: return true;
    case 0x21ce: return true;
    case 0x21cf: return true;
    case 0x21d0: return true;
    case 0x21d1: return true;
    case 0x21d2: return true;
    case 0x21d3: return true;
    case 0x21d4: return true;
    case 0x21d5: return true;
    case 0x21d6: return true;
    case 0x21d7: return true;
    case 0x21d8: return true;
    case 0x21d9: return true;
    case 0x21da: return true;
    case 0x21db: return true;
    case 0x21dc: return true;
    case 0x21dd: return true;
    case 0x21de: return true;
    case 0x21df: return true;
    case 0x21e0: return true;
    case 0x21e1: return true;
    case 0x21e2: return true;
    case 0x21e3: return true;
    case 0x21e4: return true;
    case 0x21e5: return true;
    case 0x21e6: return true;
    case 0x21e7: return true;
    case 0x21e8: return true;
    case 0x21e9: return true;
    case 0x21ea: return true;
    case 0x21eb: return true;
    case 0x21ec: return true;
    case 0x21ed: return true;
    case 0x21ee: return true;
    case 0x21ef: return true;
    case 0x21f0: return true;
    case 0x21f1: return true;
    case 0x21f2: return true;
    case 0x21f3: return true;
    case 0x21f4: return true;
    case 0x21f5: return true;
    case 0x21f6: return true;
    case 0x21f7: return true;
    case 0x21f8: return true;
    case 0x21f9: return true;
    case 0x21fa: return true;
    case 0x21fb: return true;
    case 0x21fc: return true;
    case 0x21fd: return true;
    case 0x21fe: return true;
    case 0x21ff: return true;
    case 0x2200: return true;
    case 0x2201: return true;
    case 0x2202: return true;
    case 0x2203: return true;
    case 0x2204: return true;
    case 0x2205: return true;
    case 0x2206: return true;
    case 0x2207: return true;
    case 0x2208: return true;
    case 0x2209: return true;
    case 0x220a: return true;
    case 0x220b: return true;
    case 0x220c: return true;
    case 0x220d: return true;
    case 0x220e: return true;
    case 0x220f: return true;
    case 0x2210: return true;
    case 0x2211: return true;
    case 0x2212: return true;
    case 0x2213: return true;
    case 0x2214: return true;
    case 0x2215: return true;
    case 0x2216: return true;
    case 0x2217: return true;
    case 0x2218: return true;
    case 0x2219: return true;
    case 0x221a: return true;
    case 0x221b: return true;
    case 0x221c: return true;
    case 0x221d: return true;
    case 0x221e: return true;
    case 0x221f: return true;
    case 0x2220: return true;
    case 0x2221: return true;
    case 0x2222: return true;
    case 0x2223: return true;
    case 0x2224: return true;
    case 0x2225: return true;
    case 0x2226: return true;
    case 0x2227: return true;
    case 0x2228: return true;
    case 0x2229: return true;
    case 0x222a: return true;
    case 0x222b: return true;
    case 0x222c: return true;
    case 0x222d: return true;
    case 0x222e: return true;
    case 0x222f: return true;
    case 0x2230: return true;
    case 0x2231: return true;
    case 0x2232: return true;
    case 0x2233: return true;
    case 0x2234: return true;
    case 0x2235: return true;
    case 0x2236: return true;
    case 0x2237: return true;
    case 0x2238: return true;
    case 0x2239: return true;
    case 0x223a: return true;
    case 0x223b: return true;
    case 0x223c: return true;
    case 0x223d: return true;
    case 0x223e: return true;
    case 0x223f: return true;
    case 0x2240: return true;
    case 0x2241: return true;
    case 0x2242: return true;
    case 0x2243: return true;
    case 0x2244: return true;
    case 0x2245: return true;
    case 0x2246: return true;
    case 0x2247: return true;
    case 0x2248: return true;
    case 0x2249: return true;
    case 0x224a: return true;
    case 0x224b: return true;
    case 0x224c: return true;
    case 0x224d: return true;
    case 0x224e: return true;
    case 0x224f: return true;
    case 0x2250: return true;
    case 0x2251: return true;
    case 0x2252: return true;
    case 0x2253: return true;
    case 0x2254: return true;
    case 0x2255: return true;
    case 0x2256: return true;
    case 0x2257: return true;
    case 0x2258: return true;
    case 0x2259: return true;
    case 0x225a: return true;
    case 0x225b: return true;
    case 0x225c: return true;
    case 0x225d: return true;
    case 0x225e: return true;
    case 0x225f: return true;
    case 0x2260: return true;
    case 0x2261: return true;
    case 0x2262: return true;
    case 0x2263: return true;
    case 0x2264: return true;
    case 0x2265: return true;
    case 0x2266: return true;
    case 0x2267: return true;
    case 0x2268: return true;
    case 0x2269: return true;
    case 0x226a: return true;
    case 0x226b: return true;
    case 0x226c: return true;
    case 0x226d: return true;
    case 0x226e: return true;
    case 0x226f: return true;
    case 0x2270: return true;
    case 0x2271: return true;
    case 0x2272: return true;
    case 0x2273: return true;
    case 0x2274: return true;
    case 0x2275: return true;
    case 0x2276: return true;
    case 0x2277: return true;
    case 0x2278: return true;
    case 0x2279: return true;
    case 0x227a: return true;
    case 0x227b: return true;
    case 0x227c: return true;
    case 0x227d: return true;
    case 0x227e: return true;
    case 0x227f: return true;
    case 0x2280: return true;
    case 0x2281: return true;
    case 0x2282: return true;
    case 0x2283: return true;
    case 0x2284: return true;
    case 0x2285: return true;
    case 0x2286: return true;
    case 0x2287: return true;
    case 0x2288: return true;
    case 0x2289: return true;
    case 0x228a: return true;
    case 0x228b: return true;
    case 0x228c: return true;
    case 0x228d: return true;
    case 0x228e: return true;
    case 0x228f: return true;
    case 0x2290: return true;
    case 0x2291: return true;
    case 0x2292: return true;
    case 0x2293: return true;
    case 0x2294: return true;
    case 0x2295: return true;
    case 0x2296: return true;
    case 0x2297: return true;
    case 0x2298: return true;
    case 0x2299: return true;
    case 0x229a: return true;
    case 0x229b: return true;
    case 0x229c: return true;
    case 0x229d: return true;
    case 0x229e: return true;
    case 0x229f: return true;
    case 0x22a0: return true;
    case 0x22a1: return true;
    case 0x22a2: return true;
    case 0x22a3: return true;
    case 0x22a4: return true;
    case 0x22a5: return true;
    case 0x22a6: return true;
    case 0x22a7: return true;
    case 0x22a8: return true;
    case 0x22a9: return true;
    case 0x22aa: return true;
    case 0x22ab: return true;
    case 0x22ac: return true;
    case 0x22ad: return true;
    case 0x22ae: return true;
    case 0x22af: return true;
    case 0x22b0: return true;
    case 0x22b1: return true;
    case 0x22b2: return true;
    case 0x22b3: return true;
    case 0x22b4: return true;
    case 0x22b5: return true;
    case 0x22b6: return true;
    case 0x22b7: return true;
    case 0x22b8: return true;
    case 0x22b9: return true;
    case 0x22ba: return true;
    case 0x22bb: return true;
    case 0x22bc: return true;
    case 0x22bd: return true;
    case 0x22be: return true;
    case 0x22bf: return true;
    case 0x22c0: return true;
    case 0x22c1: return true;
    case 0x22c2: return true;
    case 0x22c3: return true;
    case 0x22c4: return true;
    case 0x22c5: return true;
    case 0x22c6: return true;
    case 0x22c7: return true;
    case 0x22c8: return true;
    case 0x22c9: return true;
    case 0x22ca: return true;
    case 0x22cb: return true;
    case 0x22cc: return true;
    case 0x22cd: return true;
    case 0x22ce: return true;
    case 0x22cf: return true;
    case 0x22d0: return true;
    case 0x22d1: return true;
    case 0x22d2: return true;
    case 0x22d3: return true;
    case 0x22d4: return true;
    case 0x22d5: return true;
    case 0x22d6: return true;
    case 0x22d7: return true;
    case 0x22d8: return true;
    case 0x22d9: return true;
    case 0x22da: return true;
    case 0x22db: return true;
    case 0x22dc: return true;
    case 0x22dd: return true;
    case 0x22de: return true;
    case 0x22df: return true;
    case 0x22e0: return true;
    case 0x22e1: return true;
    case 0x22e2: return true;
    case 0x22e3: return true;
    case 0x22e4: return true;
    case 0x22e5: return true;
    case 0x22e6: return true;
    case 0x22e7: return true;
    case 0x22e8: return true;
    case 0x22e9: return true;
    case 0x22ea: return true;
    case 0x22eb: return true;
    case 0x22ec: return true;
    case 0x22ed: return true;
    case 0x22ee: return true;
    case 0x22ef: return true;
    case 0x22f0: return true;
    case 0x22f1: return true;
    case 0x22f2: return true;
    case 0x22f3: return true;
    case 0x22f4: return true;
    case 0x22f5: return true;
    case 0x22f6: return true;
    case 0x22f7: return true;
    case 0x22f8: return true;
    case 0x22f9: return true;
    case 0x22fa: return true;
    case 0x22fb: return true;
    case 0x22fc: return true;
    case 0x22fd: return true;
    case 0x22fe: return true;
    case 0x22ff: return true;
    case 0x2300: return true;
    case 0x2301: return true;
    case 0x2302: return true;
    case 0x2303: return true;
    case 0x2304: return true;
    case 0x2305: return true;
    case 0x2306: return true;
    case 0x2307: return true;
    case 0x2308: return true;
    case 0x2309: return true;
    case 0x230a: return true;
    case 0x230b: return true;
    case 0x230c: return true;
    case 0x230d: return true;
    case 0x230e: return true;
    case 0x230f: return true;
    case 0x2310: return true;
    case 0x2311: return true;
    case 0x2312: return true;
    case 0x2313: return true;
    case 0x2314: return true;
    case 0x2315: return true;
    case 0x2316: return true;
    case 0x2317: return true;
    case 0x2318: return true;
    case 0x2319: return true;
    case 0x231a: return true;
    case 0x231b: return true;
    case 0x231c: return true;
    case 0x231d: return true;
    case 0x231e: return true;
    case 0x231f: return true;
    case 0x2320: return true;
    case 0x2321: return true;
    case 0x2322: return true;
    case 0x2323: return true;
    case 0x2324: return true;
    case 0x2325: return true;
    case 0x2326: return true;
    case 0x2327: return true;
    case 0x2328: return true;
    case 0x2329: return true;
    case 0x232a: return true;
    case 0x232b: return true;
    case 0x232c: return true;
    case 0x232d: return true;
    case 0x232e: return true;
    case 0x232f: return true;
    case 0x2330: return true;
    case 0x2331: return true;
    case 0x2332: return true;
    case 0x2333: return true;
    case 0x2334: return true;
    case 0x2335: return true;
    case 0x2336: return true;
    case 0x2337: return true;
    case 0x2338: return true;
    case 0x2339: return true;
    case 0x233a: return true;
    case 0x233b: return true;
    case 0x233c: return true;
    case 0x233d: return true;
    case 0x233e: return true;
    case 0x233f: return true;
    case 0x2340: return true;
    case 0x2341: return true;
    case 0x2342: return true;
    case 0x2343: return true;
    case 0x2344: return true;
    case 0x2345: return true;
    case 0x2346: return true;
    case 0x2347: return true;
    case 0x2348: return true;
    case 0x2349: return true;
    case 0x234a: return true;
    case 0x234b: return true;
    case 0x234c: return true;
    case 0x234d: return true;
    case 0x234e: return true;
    case 0x234f: return true;
    case 0x2350: return true;
    case 0x2351: return true;
    case 0x2352: return true;
    case 0x2353: return true;
    case 0x2354: return true;
    case 0x2355: return true;
    case 0x2356: return true;
    case 0x2357: return true;
    case 0x2358: return true;
    case 0x2359: return true;
    case 0x235a: return true;
    case 0x235b: return true;
    case 0x235c: return true;
    case 0x235d: return true;
    case 0x235e: return true;
    case 0x235f: return true;
    case 0x2360: return true;
    case 0x2361: return true;
    case 0x2362: return true;
    case 0x2363: return true;
    case 0x2364: return true;
    case 0x2365: return true;
    case 0x2366: return true;
    case 0x2367: return true;
    case 0x2368: return true;
    case 0x2369: return true;
    case 0x236a: return true;
    case 0x236b: return true;
    case 0x236c: return true;
    case 0x236d: return true;
    case 0x236e: return true;
    case 0x236f: return true;
    case 0x2370: return true;
    case 0x2371: return true;
    case 0x2372: return true;
    case 0x2373: return true;
    case 0x2374: return true;
    case 0x2375: return true;
    case 0x2376: return true;
    case 0x2377: return true;
    case 0x2378: return true;
    case 0x2379: return true;
    case 0x237a: return true;
    case 0x237b: return true;
    case 0x237c: return true;
    case 0x237d: return true;
    case 0x237e: return true;
    case 0x237f: return true;
    case 0x2380: return true;
    case 0x2381: return true;
    case 0x2382: return true;
    case 0x2383: return true;
    case 0x2384: return true;
    case 0x2385: return true;
    case 0x2386: return true;
    case 0x2387: return true;
    case 0x2388: return true;
    case 0x2389: return true;
    case 0x238a: return true;
    case 0x238b: return true;
    case 0x238c: return true;
    case 0x238d: return true;
    case 0x238e: return true;
    case 0x238f: return true;
    case 0x2390: return true;
    case 0x2391: return true;
    case 0x2392: return true;
    case 0x2393: return true;
    case 0x2394: return true;
    case 0x2395: return true;
    case 0x2396: return true;
    case 0x2397: return true;
    case 0x2398: return true;
    case 0x2399: return true;
    case 0x239a: return true;
    case 0x239b: return true;
    case 0x239c: return true;
    case 0x239d: return true;
    case 0x239e: return true;
    case 0x239f: return true;
    case 0x23a0: return true;
    case 0x23a1: return true;
    case 0x23a2: return true;
    case 0x23a3: return true;
    case 0x23a4: return true;
    case 0x23a5: return true;
    case 0x23a6: return true;
    case 0x23a7: return true;
    case 0x23a8: return true;
    case 0x23a9: return true;
    case 0x23aa: return true;
    case 0x23ab: return true;
    case 0x23ac: return true;
    case 0x23ad: return true;
    case 0x23ae: return true;
    case 0x23af: return true;
    case 0x23b0: return true;
    case 0x23b1: return true;
    case 0x23b2: return true;
    case 0x23b3: return true;
    case 0x23b4: return true;
    case 0x23b5: return true;
    case 0x23b6: return true;
    case 0x23b7: return true;
    case 0x23b8: return true;
    case 0x23b9: return true;
    case 0x23ba: return true;
    case 0x23bb: return true;
    case 0x23bc: return true;
    case 0x23bd: return true;
    case 0x23be: return true;
    case 0x23bf: return true;
    case 0x23c0: return true;
    case 0x23c1: return true;
    case 0x23c2: return true;
    case 0x23c3: return true;
    case 0x23c4: return true;
    case 0x23c5: return true;
    case 0x23c6: return true;
    case 0x23c7: return true;
    case 0x23c8: return true;
    case 0x23c9: return true;
    case 0x23ca: return true;
    case 0x23cb: return true;
    case 0x23cc: return true;
    case 0x23cd: return true;
    case 0x23ce: return true;
    case 0x23cf: return true;
    case 0x23d0: return true;
    case 0x23d1: return true;
    case 0x23d2: return true;
    case 0x23d3: return true;
    case 0x23d4: return true;
    case 0x23d5: return true;
    case 0x23d6: return true;
    case 0x23d7: return true;
    case 0x23d8: return true;
    case 0x23d9: return true;
    case 0x23da: return true;
    case 0x23db: return true;
    case 0x23dc: return true;
    case 0x23dd: return true;
    case 0x23de: return true;
    case 0x23df: return true;
    case 0x23e0: return true;
    case 0x23e1: return true;
    case 0x23e2: return true;
    case 0x23e3: return true;
    case 0x23e4: return true;
    case 0x23e5: return true;
    case 0x23e6: return true;
    case 0x23e7: return true;
    case 0x23e8: return true;
    case 0x23e9: return true;
    case 0x23ea: return true;
    case 0x23eb: return true;
    case 0x23ec: return true;
    case 0x23ed: return true;
    case 0x23ee: return true;
    case 0x23ef: return true;
    case 0x23f0: return true;
    case 0x23f1: return true;
    case 0x23f2: return true;
    case 0x23f3: return true;
    case 0x23f4: return true;
    case 0x23f5: return true;
    case 0x23f6: return true;
    case 0x23f7: return true;
    case 0x23f8: return true;
    case 0x23f9: return true;
    case 0x23fa: return true;
    case 0x23fb: return true;
    case 0x23fc: return true;
    case 0x23fd: return true;
    case 0x23fe: return true;
    case 0x23ff: return true;
    case 0x2400: return true;
    case 0x2401: return true;
    case 0x2402: return true;
    case 0x2403: return true;
    case 0x2404: return true;
    case 0x2405: return true;
    case 0x2406: return true;
    case 0x2407: return true;
    case 0x2408: return true;
    case 0x2409: return true;
    case 0x240a: return true;
    case 0x240b: return true;
    case 0x240c: return true;
    case 0x240d: return true;
    case 0x240e: return true;
    case 0x240f: return true;
    case 0x2410: return true;
    case 0x2411: return true;
    case 0x2412: return true;
    case 0x2413: return true;
    case 0x2414: return true;
    case 0x2415: return true;
    case 0x2416: return true;
    case 0x2417: return true;
    case 0x2418: return true;
    case 0x2419: return true;
    case 0x241a: return true;
    case 0x241b: return true;
    case 0x241c: return true;
    case 0x241d: return true;
    case 0x241e: return true;
    case 0x241f: return true;
    case 0x2420: return true;
    case 0x2421: return true;
    case 0x2422: return true;
    case 0x2423: return true;
    case 0x2424: return true;
    case 0x2425: return true;
    case 0x2426: return true;
    case 0x2427: return true;
    case 0x2428: return true;
    case 0x2429: return true;
    case 0x242a: return true;
    case 0x242b: return true;
    case 0x242c: return true;
    case 0x242d: return true;
    case 0x242e: return true;
    case 0x242f: return true;
    case 0x2430: return true;
    case 0x2431: return true;
    case 0x2432: return true;
    case 0x2433: return true;
    case 0x2434: return true;
    case 0x2435: return true;
    case 0x2436: return true;
    case 0x2437: return true;
    case 0x2438: return true;
    case 0x2439: return true;
    case 0x243a: return true;
    case 0x243b: return true;
    case 0x243c: return true;
    case 0x243d: return true;
    case 0x243e: return true;
    case 0x243f: return true;
    case 0x2440: return true;
    case 0x2441: return true;
    case 0x2442: return true;
    case 0x2443: return true;
    case 0x2444: return true;
    case 0x2445: return true;
    case 0x2446: return true;
    case 0x2447: return true;
    case 0x2448: return true;
    case 0x2449: return true;
    case 0x244a: return true;
    case 0x244b: return true;
    case 0x244c: return true;
    case 0x244d: return true;
    case 0x244e: return true;
    case 0x244f: return true;
    case 0x2450: return true;
    case 0x2451: return true;
    case 0x2452: return true;
    case 0x2453: return true;
    case 0x2454: return true;
    case 0x2455: return true;
    case 0x2456: return true;
    case 0x2457: return true;
    case 0x2458: return true;
    case 0x2459: return true;
    case 0x245a: return true;
    case 0x245b: return true;
    case 0x245c: return true;
    case 0x245d: return true;
    case 0x245e: return true;
    case 0x245f: return true;
    case 0x2500: return true;
    case 0x2501: return true;
    case 0x2502: return true;
    case 0x2503: return true;
    case 0x2504: return true;
    case 0x2505: return true;
    case 0x2506: return true;
    case 0x2507: return true;
    case 0x2508: return true;
    case 0x2509: return true;
    case 0x250a: return true;
    case 0x250b: return true;
    case 0x250c: return true;
    case 0x250d: return true;
    case 0x250e: return true;
    case 0x250f: return true;
    case 0x2510: return true;
    case 0x2511: return true;
    case 0x2512: return true;
    case 0x2513: return true;
    case 0x2514: return true;
    case 0x2515: return true;
    case 0x2516: return true;
    case 0x2517: return true;
    case 0x2518: return true;
    case 0x2519: return true;
    case 0x251a: return true;
    case 0x251b: return true;
    case 0x251c: return true;
    case 0x251d: return true;
    case 0x251e: return true;
    case 0x251f: return true;
    case 0x2520: return true;
    case 0x2521: return true;
    case 0x2522: return true;
    case 0x2523: return true;
    case 0x2524: return true;
    case 0x2525: return true;
    case 0x2526: return true;
    case 0x2527: return true;
    case 0x2528: return true;
    case 0x2529: return true;
    case 0x252a: return true;
    case 0x252b: return true;
    case 0x252c: return true;
    case 0x252d: return true;
    case 0x252e: return true;
    case 0x252f: return true;
    case 0x2530: return true;
    case 0x2531: return true;
    case 0x2532: return true;
    case 0x2533: return true;
    case 0x2534: return true;
    case 0x2535: return true;
    case 0x2536: return true;
    case 0x2537: return true;
    case 0x2538: return true;
    case 0x2539: return true;
    case 0x253a: return true;
    case 0x253b: return true;
    case 0x253c: return true;
    case 0x253d: return true;
    case 0x253e: return true;
    case 0x253f: return true;
    case 0x2540: return true;
    case 0x2541: return true;
    case 0x2542: return true;
    case 0x2543: return true;
    case 0x2544: return true;
    case 0x2545: return true;
    case 0x2546: return true;
    case 0x2547: return true;
    case 0x2548: return true;
    case 0x2549: return true;
    case 0x254a: return true;
    case 0x254b: return true;
    case 0x254c: return true;
    case 0x254d: return true;
    case 0x254e: return true;
    case 0x254f: return true;
    case 0x2550: return true;
    case 0x2551: return true;
    case 0x2552: return true;
    case 0x2553: return true;
    case 0x2554: return true;
    case 0x2555: return true;
    case 0x2556: return true;
    case 0x2557: return true;
    case 0x2558: return true;
    case 0x2559: return true;
    case 0x255a: return true;
    case 0x255b: return true;
    case 0x255c: return true;
    case 0x255d: return true;
    case 0x255e: return true;
    case 0x255f: return true;
    case 0x2560: return true;
    case 0x2561: return true;
    case 0x2562: return true;
    case 0x2563: return true;
    case 0x2564: return true;
    case 0x2565: return true;
    case 0x2566: return true;
    case 0x2567: return true;
    case 0x2568: return true;
    case 0x2569: return true;
    case 0x256a: return true;
    case 0x256b: return true;
    case 0x256c: return true;
    case 0x256d: return true;
    case 0x256e: return true;
    case 0x256f: return true;
    case 0x2570: return true;
    case 0x2571: return true;
    case 0x2572: return true;
    case 0x2573: return true;
    case 0x2574: return true;
    case 0x2575: return true;
    case 0x2576: return true;
    case 0x2577: return true;
    case 0x2578: return true;
    case 0x2579: return true;
    case 0x257a: return true;
    case 0x257b: return true;
    case 0x257c: return true;
    case 0x257d: return true;
    case 0x257e: return true;
    case 0x257f: return true;
    case 0x2580: return true;
    case 0x2581: return true;
    case 0x2582: return true;
    case 0x2583: return true;
    case 0x2584: return true;
    case 0x2585: return true;
    case 0x2586: return true;
    case 0x2587: return true;
    case 0x2588: return true;
    case 0x2589: return true;
    case 0x258a: return true;
    case 0x258b: return true;
    case 0x258c: return true;
    case 0x258d: return true;
    case 0x258e: return true;
    case 0x258f: return true;
    case 0x2590: return true;
    case 0x2591: return true;
    case 0x2592: return true;
    case 0x2593: return true;
    case 0x2594: return true;
    case 0x2595: return true;
    case 0x2596: return true;
    case 0x2597: return true;
    case 0x2598: return true;
    case 0x2599: return true;
    case 0x259a: return true;
    case 0x259b: return true;
    case 0x259c: return true;
    case 0x259d: return true;
    case 0x259e: return true;
    case 0x259f: return true;
    case 0x25a0: return true;
    case 0x25a1: return true;
    case 0x25a2: return true;
    case 0x25a3: return true;
    case 0x25a4: return true;
    case 0x25a5: return true;
    case 0x25a6: return true;
    case 0x25a7: return true;
    case 0x25a8: return true;
    case 0x25a9: return true;
    case 0x25aa: return true;
    case 0x25ab: return true;
    case 0x25ac: return true;
    case 0x25ad: return true;
    case 0x25ae: return true;
    case 0x25af: return true;
    case 0x25b0: return true;
    case 0x25b1: return true;
    case 0x25b2: return true;
    case 0x25b3: return true;
    case 0x25b4: return true;
    case 0x25b5: return true;
    case 0x25b6: return true;
    case 0x25b7: return true;
    case 0x25b8: return true;
    case 0x25b9: return true;
    case 0x25ba: return true;
    case 0x25bb: return true;
    case 0x25bc: return true;
    case 0x25bd: return true;
    case 0x25be: return true;
    case 0x25bf: return true;
    case 0x25c0: return true;
    case 0x25c1: return true;
    case 0x25c2: return true;
    case 0x25c3: return true;
    case 0x25c4: return true;
    case 0x25c5: return true;
    case 0x25c6: return true;
    case 0x25c7: return true;
    case 0x25c8: return true;
    case 0x25c9: return true;
    case 0x25ca: return true;
    case 0x25cb: return true;
    case 0x25cc: return true;
    case 0x25cd: return true;
    case 0x25ce: return true;
    case 0x25cf: return true;
    case 0x25d0: return true;
    case 0x25d1: return true;
    case 0x25d2: return true;
    case 0x25d3: return true;
    case 0x25d4: return true;
    case 0x25d5: return true;
    case 0x25d6: return true;
    case 0x25d7: return true;
    case 0x25d8: return true;
    case 0x25d9: return true;
    case 0x25da: return true;
    case 0x25db: return true;
    case 0x25dc: return true;
    case 0x25dd: return true;
    case 0x25de: return true;
    case 0x25df: return true;
    case 0x25e0: return true;
    case 0x25e1: return true;
    case 0x25e2: return true;
    case 0x25e3: return true;
    case 0x25e4: return true;
    case 0x25e5: return true;
    case 0x25e6: return true;
    case 0x25e7: return true;
    case 0x25e8: return true;
    case 0x25e9: return true;
    case 0x25ea: return true;
    case 0x25eb: return true;
    case 0x25ec: return true;
    case 0x25ed: return true;
    case 0x25ee: return true;
    case 0x25ef: return true;
    case 0x25f0: return true;
    case 0x25f1: return true;
    case 0x25f2: return true;
    case 0x25f3: return true;
    case 0x25f4: return true;
    case 0x25f5: return true;
    case 0x25f6: return true;
    case 0x25f7: return true;
    case 0x25f8: return true;
    case 0x25f9: return true;
    case 0x25fa: return true;
    case 0x25fb: return true;
    case 0x25fc: return true;
    case 0x25fd: return true;
    case 0x25fe: return true;
    case 0x25ff: return true;
    case 0x2600: return true;
    case 0x2601: return true;
    case 0x2602: return true;
    case 0x2603: return true;
    case 0x2604: return true;
    case 0x2605: return true;
    case 0x2606: return true;
    case 0x2607: return true;
    case 0x2608: return true;
    case 0x2609: return true;
    case 0x260a: return true;
    case 0x260b: return true;
    case 0x260c: return true;
    case 0x260d: return true;
    case 0x260e: return true;
    case 0x260f: return true;
    case 0x2610: return true;
    case 0x2611: return true;
    case 0x2612: return true;
    case 0x2613: return true;
    case 0x2614: return true;
    case 0x2615: return true;
    case 0x2616: return true;
    case 0x2617: return true;
    case 0x2618: return true;
    case 0x2619: return true;
    case 0x261a: return true;
    case 0x261b: return true;
    case 0x261c: return true;
    case 0x261d: return true;
    case 0x261e: return true;
    case 0x261f: return true;
    case 0x2620: return true;
    case 0x2621: return true;
    case 0x2622: return true;
    case 0x2623: return true;
    case 0x2624: return true;
    case 0x2625: return true;
    case 0x2626: return true;
    case 0x2627: return true;
    case 0x2628: return true;
    case 0x2629: return true;
    case 0x262a: return true;
    case 0x262b: return true;
    case 0x262c: return true;
    case 0x262d: return true;
    case 0x262e: return true;
    case 0x262f: return true;
    case 0x2630: return true;
    case 0x2631: return true;
    case 0x2632: return true;
    case 0x2633: return true;
    case 0x2634: return true;
    case 0x2635: return true;
    case 0x2636: return true;
    case 0x2637: return true;
    case 0x2638: return true;
    case 0x2639: return true;
    case 0x263a: return true;
    case 0x263b: return true;
    case 0x263c: return true;
    case 0x263d: return true;
    case 0x263e: return true;
    case 0x263f: return true;
    case 0x2640: return true;
    case 0x2641: return true;
    case 0x2642: return true;
    case 0x2643: return true;
    case 0x2644: return true;
    case 0x2645: return true;
    case 0x2646: return true;
    case 0x2647: return true;
    case 0x2648: return true;
    case 0x2649: return true;
    case 0x264a: return true;
    case 0x264b: return true;
    case 0x264c: return true;
    case 0x264d: return true;
    case 0x264e: return true;
    case 0x264f: return true;
    case 0x2650: return true;
    case 0x2651: return true;
    case 0x2652: return true;
    case 0x2653: return true;
    case 0x2654: return true;
    case 0x2655: return true;
    case 0x2656: return true;
    case 0x2657: return true;
    case 0x2658: return true;
    case 0x2659: return true;
    case 0x265a: return true;
    case 0x265b: return true;
    case 0x265c: return true;
    case 0x265d: return true;
    case 0x265e: return true;
    case 0x265f: return true;
    case 0x2660: return true;
    case 0x2661: return true;
    case 0x2662: return true;
    case 0x2663: return true;
    case 0x2664: return true;
    case 0x2665: return true;
    case 0x2666: return true;
    case 0x2667: return true;
    case 0x2668: return true;
    case 0x2669: return true;
    case 0x266a: return true;
    case 0x266b: return true;
    case 0x266c: return true;
    case 0x266d: return true;
    case 0x266e: return true;
    case 0x266f: return true;
    case 0x2670: return true;
    case 0x2671: return true;
    case 0x2672: return true;
    case 0x2673: return true;
    case 0x2674: return true;
    case 0x2675: return true;
    case 0x2676: return true;
    case 0x2677: return true;
    case 0x2678: return true;
    case 0x2679: return true;
    case 0x267a: return true;
    case 0x267b: return true;
    case 0x267c: return true;
    case 0x267d: return true;
    case 0x267e: return true;
    case 0x267f: return true;
    case 0x2680: return true;
    case 0x2681: return true;
    case 0x2682: return true;
    case 0x2683: return true;
    case 0x2684: return true;
    case 0x2685: return true;
    case 0x2686: return true;
    case 0x2687: return true;
    case 0x2688: return true;
    case 0x2689: return true;
    case 0x268a: return true;
    case 0x268b: return true;
    case 0x268c: return true;
    case 0x268d: return true;
    case 0x268e: return true;
    case 0x268f: return true;
    case 0x2690: return true;
    case 0x2691: return true;
    case 0x2692: return true;
    case 0x2693: return true;
    case 0x2694: return true;
    case 0x2695: return true;
    case 0x2696: return true;
    case 0x2697: return true;
    case 0x2698: return true;
    case 0x2699: return true;
    case 0x269a: return true;
    case 0x269b: return true;
    case 0x269c: return true;
    case 0x269d: return true;
    case 0x269e: return true;
    case 0x269f: return true;
    case 0x26a0: return true;
    case 0x26a1: return true;
    case 0x26a2: return true;
    case 0x26a3: return true;
    case 0x26a4: return true;
    case 0x26a5: return true;
    case 0x26a6: return true;
    case 0x26a7: return true;
    case 0x26a8: return true;
    case 0x26a9: return true;
    case 0x26aa: return true;
    case 0x26ab: return true;
    case 0x26ac: return true;
    case 0x26ad: return true;
    case 0x26ae: return true;
    case 0x26af: return true;
    case 0x26b0: return true;
    case 0x26b1: return true;
    case 0x26b2: return true;
    case 0x26b3: return true;
    case 0x26b4: return true;
    case 0x26b5: return true;
    case 0x26b6: return true;
    case 0x26b7: return true;
    case 0x26b8: return true;
    case 0x26b9: return true;
    case 0x26ba: return true;
    case 0x26bb: return true;
    case 0x26bc: return true;
    case 0x26bd: return true;
    case 0x26be: return true;
    case 0x26bf: return true;
    case 0x26c0: return true;
    case 0x26c1: return true;
    case 0x26c2: return true;
    case 0x26c3: return true;
    case 0x26c4: return true;
    case 0x26c5: return true;
    case 0x26c6: return true;
    case 0x26c7: return true;
    case 0x26c8: return true;
    case 0x26c9: return true;
    case 0x26ca: return true;
    case 0x26cb: return true;
    case 0x26cc: return true;
    case 0x26cd: return true;
    case 0x26ce: return true;
    case 0x26cf: return true;
    case 0x26d0: return true;
    case 0x26d1: return true;
    case 0x26d2: return true;
    case 0x26d3: return true;
    case 0x26d4: return true;
    case 0x26d5: return true;
    case 0x26d6: return true;
    case 0x26d7: return true;
    case 0x26d8: return true;
    case 0x26d9: return true;
    case 0x26da: return true;
    case 0x26db: return true;
    case 0x26dc: return true;
    case 0x26dd: return true;
    case 0x26de: return true;
    case 0x26df: return true;
    case 0x26e0: return true;
    case 0x26e1: return true;
    case 0x26e2: return true;
    case 0x26e3: return true;
    case 0x26e4: return true;
    case 0x26e5: return true;
    case 0x26e6: return true;
    case 0x26e7: return true;
    case 0x26e8: return true;
    case 0x26e9: return true;
    case 0x26ea: return true;
    case 0x26eb: return true;
    case 0x26ec: return true;
    case 0x26ed: return true;
    case 0x26ee: return true;
    case 0x26ef: return true;
    case 0x26f0: return true;
    case 0x26f1: return true;
    case 0x26f2: return true;
    case 0x26f3: return true;
    case 0x26f4: return true;
    case 0x26f5: return true;
    case 0x26f6: return true;
    case 0x26f7: return true;
    case 0x26f8: return true;
    case 0x26f9: return true;
    case 0x26fa: return true;
    case 0x26fb: return true;
    case 0x26fc: return true;
    case 0x26fd: return true;
    case 0x26fe: return true;
    case 0x26ff: return true;
    case 0x2700: return true;
    case 0x2701: return true;
    case 0x2702: return true;
    case 0x2703: return true;
    case 0x2704: return true;
    case 0x2705: return true;
    case 0x2706: return true;
    case 0x2707: return true;
    case 0x2708: return true;
    case 0x2709: return true;
    case 0x270a: return true;
    case 0x270b: return true;
    case 0x270c: return true;
    case 0x270d: return true;
    case 0x270e: return true;
    case 0x270f: return true;
    case 0x2710: return true;
    case 0x2711: return true;
    case 0x2712: return true;
    case 0x2713: return true;
    case 0x2714: return true;
    case 0x2715: return true;
    case 0x2716: return true;
    case 0x2717: return true;
    case 0x2718: return true;
    case 0x2719: return true;
    case 0x271a: return true;
    case 0x271b: return true;
    case 0x271c: return true;
    case 0x271d: return true;
    case 0x271e: return true;
    case 0x271f: return true;
    case 0x2720: return true;
    case 0x2721: return true;
    case 0x2722: return true;
    case 0x2723: return true;
    case 0x2724: return true;
    case 0x2725: return true;
    case 0x2726: return true;
    case 0x2727: return true;
    case 0x2728: return true;
    case 0x2729: return true;
    case 0x272a: return true;
    case 0x272b: return true;
    case 0x272c: return true;
    case 0x272d: return true;
    case 0x272e: return true;
    case 0x272f: return true;
    case 0x2730: return true;
    case 0x2731: return true;
    case 0x2732: return true;
    case 0x2733: return true;
    case 0x2734: return true;
    case 0x2735: return true;
    case 0x2736: return true;
    case 0x2737: return true;
    case 0x2738: return true;
    case 0x2739: return true;
    case 0x273a: return true;
    case 0x273b: return true;
    case 0x273c: return true;
    case 0x273d: return true;
    case 0x273e: return true;
    case 0x273f: return true;
    case 0x2740: return true;
    case 0x2741: return true;
    case 0x2742: return true;
    case 0x2743: return true;
    case 0x2744: return true;
    case 0x2745: return true;
    case 0x2746: return true;
    case 0x2747: return true;
    case 0x2748: return true;
    case 0x2749: return true;
    case 0x274a: return true;
    case 0x274b: return true;
    case 0x274c: return true;
    case 0x274d: return true;
    case 0x274e: return true;
    case 0x274f: return true;
    case 0x2750: return true;
    case 0x2751: return true;
    case 0x2752: return true;
    case 0x2753: return true;
    case 0x2754: return true;
    case 0x2755: return true;
    case 0x2756: return true;
    case 0x2757: return true;
    case 0x2758: return true;
    case 0x2759: return true;
    case 0x275a: return true;
    case 0x275b: return true;
    case 0x275c: return true;
    case 0x275d: return true;
    case 0x275e: return true;
    case 0x275f: return true;
    case 0x2760: return true;
    case 0x2761: return true;
    case 0x2762: return true;
    case 0x2763: return true;
    case 0x2764: return true;
    case 0x2765: return true;
    case 0x2766: return true;
    case 0x2767: return true;
    case 0x2768: return true;
    case 0x2769: return true;
    case 0x276a: return true;
    case 0x276b: return true;
    case 0x276c: return true;
    case 0x276d: return true;
    case 0x276e: return true;
    case 0x276f: return true;
    case 0x2770: return true;
    case 0x2771: return true;
    case 0x2772: return true;
    case 0x2773: return true;
    case 0x2774: return true;
    case 0x2775: return true;
    case 0x2794: return true;
    case 0x2795: return true;
    case 0x2796: return true;
    case 0x2797: return true;
    case 0x2798: return true;
    case 0x2799: return true;
    case 0x279a: return true;
    case 0x279b: return true;
    case 0x279c: return true;
    case 0x279d: return true;
    case 0x279e: return true;
    case 0x279f: return true;
    case 0x27a0: return true;
    case 0x27a1: return true;
    case 0x27a2: return true;
    case 0x27a3: return true;
    case 0x27a4: return true;
    case 0x27a5: return true;
    case 0x27a6: return true;
    case 0x27a7: return true;
    case 0x27a8: return true;
    case 0x27a9: return true;
    case 0x27aa: return true;
    case 0x27ab: return true;
    case 0x27ac: return true;
    case 0x27ad: return true;
    case 0x27ae: return true;
    case 0x27af: return true;
    case 0x27b0: return true;
    case 0x27b1: return true;
    case 0x27b2: return true;
    case 0x27b3: return true;
    case 0x27b4: return true;
    case 0x27b5: return true;
    case 0x27b6: return true;
    case 0x27b7: return true;
    case 0x27b8: return true;
    case 0x27b9: return true;
    case 0x27ba: return true;
    case 0x27bb: return true;
    case 0x27bc: return true;
    case 0x27bd: return true;
    case 0x27be: return true;
    case 0x27bf: return true;
    case 0x27c0: return true;
    case 0x27c1: return true;
    case 0x27c2: return true;
    case 0x27c3: return true;
    case 0x27c4: return true;
    case 0x27c5: return true;
    case 0x27c6: return true;
    case 0x27c7: return true;
    case 0x27c8: return true;
    case 0x27c9: return true;
    case 0x27ca: return true;
    case 0x27cb: return true;
    case 0x27cc: return true;
    case 0x27cd: return true;
    case 0x27ce: return true;
    case 0x27cf: return true;
    case 0x27d0: return true;
    case 0x27d1: return true;
    case 0x27d2: return true;
    case 0x27d3: return true;
    case 0x27d4: return true;
    case 0x27d5: return true;
    case 0x27d6: return true;
    case 0x27d7: return true;
    case 0x27d8: return true;
    case 0x27d9: return true;
    case 0x27da: return true;
    case 0x27db: return true;
    case 0x27dc: return true;
    case 0x27dd: return true;
    case 0x27de: return true;
    case 0x27df: return true;
    case 0x27e0: return true;
    case 0x27e1: return true;
    case 0x27e2: return true;
    case 0x27e3: return true;
    case 0x27e4: return true;
    case 0x27e5: return true;
    case 0x27e6: return true;
    case 0x27e7: return true;
    case 0x27e8: return true;
    case 0x27e9: return true;
    case 0x27ea: return true;
    case 0x27eb: return true;
    case 0x27ec: return true;
    case 0x27ed: return true;
    case 0x27ee: return true;
    case 0x27ef: return true;
    case 0x27f0: return true;
    case 0x27f1: return true;
    case 0x27f2: return true;
    case 0x27f3: return true;
    case 0x27f4: return true;
    case 0x27f5: return true;
    case 0x27f6: return true;
    case 0x27f7: return true;
    case 0x27f8: return true;
    case 0x27f9: return true;
    case 0x27fa: return true;
    case 0x27fb: return true;
    case 0x27fc: return true;
    case 0x27fd: return true;
    case 0x27fe: return true;
    case 0x27ff: return true;
    case 0x2800: return true;
    case 0x2801: return true;
    case 0x2802: return true;
    case 0x2803: return true;
    case 0x2804: return true;
    case 0x2805: return true;
    case 0x2806: return true;
    case 0x2807: return true;
    case 0x2808: return true;
    case 0x2809: return true;
    case 0x280a: return true;
    case 0x280b: return true;
    case 0x280c: return true;
    case 0x280d: return true;
    case 0x280e: return true;
    case 0x280f: return true;
    case 0x2810: return true;
    case 0x2811: return true;
    case 0x2812: return true;
    case 0x2813: return true;
    case 0x2814: return true;
    case 0x2815: return true;
    case 0x2816: return true;
    case 0x2817: return true;
    case 0x2818: return true;
    case 0x2819: return true;
    case 0x281a: return true;
    case 0x281b: return true;
    case 0x281c: return true;
    case 0x281d: return true;
    case 0x281e: return true;
    case 0x281f: return true;
    case 0x2820: return true;
    case 0x2821: return true;
    case 0x2822: return true;
    case 0x2823: return true;
    case 0x2824: return true;
    case 0x2825: return true;
    case 0x2826: return true;
    case 0x2827: return true;
    case 0x2828: return true;
    case 0x2829: return true;
    case 0x282a: return true;
    case 0x282b: return true;
    case 0x282c: return true;
    case 0x282d: return true;
    case 0x282e: return true;
    case 0x282f: return true;
    case 0x2830: return true;
    case 0x2831: return true;
    case 0x2832: return true;
    case 0x2833: return true;
    case 0x2834: return true;
    case 0x2835: return true;
    case 0x2836: return true;
    case 0x2837: return true;
    case 0x2838: return true;
    case 0x2839: return true;
    case 0x283a: return true;
    case 0x283b: return true;
    case 0x283c: return true;
    case 0x283d: return true;
    case 0x283e: return true;
    case 0x283f: return true;
    case 0x2840: return true;
    case 0x2841: return true;
    case 0x2842: return true;
    case 0x2843: return true;
    case 0x2844: return true;
    case 0x2845: return true;
    case 0x2846: return true;
    case 0x2847: return true;
    case 0x2848: return true;
    case 0x2849: return true;
    case 0x284a: return true;
    case 0x284b: return true;
    case 0x284c: return true;
    case 0x284d: return true;
    case 0x284e: return true;
    case 0x284f: return true;
    case 0x2850: return true;
    case 0x2851: return true;
    case 0x2852: return true;
    case 0x2853: return true;
    case 0x2854: return true;
    case 0x2855: return true;
    case 0x2856: return true;
    case 0x2857: return true;
    case 0x2858: return true;
    case 0x2859: return true;
    case 0x285a: return true;
    case 0x285b: return true;
    case 0x285c: return true;
    case 0x285d: return true;
    case 0x285e: return true;
    case 0x285f: return true;
    case 0x2860: return true;
    case 0x2861: return true;
    case 0x2862: return true;
    case 0x2863: return true;
    case 0x2864: return true;
    case 0x2865: return true;
    case 0x2866: return true;
    case 0x2867: return true;
    case 0x2868: return true;
    case 0x2869: return true;
    case 0x286a: return true;
    case 0x286b: return true;
    case 0x286c: return true;
    case 0x286d: return true;
    case 0x286e: return true;
    case 0x286f: return true;
    case 0x2870: return true;
    case 0x2871: return true;
    case 0x2872: return true;
    case 0x2873: return true;
    case 0x2874: return true;
    case 0x2875: return true;
    case 0x2876: return true;
    case 0x2877: return true;
    case 0x2878: return true;
    case 0x2879: return true;
    case 0x287a: return true;
    case 0x287b: return true;
    case 0x287c: return true;
    case 0x287d: return true;
    case 0x287e: return true;
    case 0x287f: return true;
    case 0x2880: return true;
    case 0x2881: return true;
    case 0x2882: return true;
    case 0x2883: return true;
    case 0x2884: return true;
    case 0x2885: return true;
    case 0x2886: return true;
    case 0x2887: return true;
    case 0x2888: return true;
    case 0x2889: return true;
    case 0x288a: return true;
    case 0x288b: return true;
    case 0x288c: return true;
    case 0x288d: return true;
    case 0x288e: return true;
    case 0x288f: return true;
    case 0x2890: return true;
    case 0x2891: return true;
    case 0x2892: return true;
    case 0x2893: return true;
    case 0x2894: return true;
    case 0x2895: return true;
    case 0x2896: return true;
    case 0x2897: return true;
    case 0x2898: return true;
    case 0x2899: return true;
    case 0x289a: return true;
    case 0x289b: return true;
    case 0x289c: return true;
    case 0x289d: return true;
    case 0x289e: return true;
    case 0x289f: return true;
    case 0x28a0: return true;
    case 0x28a1: return true;
    case 0x28a2: return true;
    case 0x28a3: return true;
    case 0x28a4: return true;
    case 0x28a5: return true;
    case 0x28a6: return true;
    case 0x28a7: return true;
    case 0x28a8: return true;
    case 0x28a9: return true;
    case 0x28aa: return true;
    case 0x28ab: return true;
    case 0x28ac: return true;
    case 0x28ad: return true;
    case 0x28ae: return true;
    case 0x28af: return true;
    case 0x28b0: return true;
    case 0x28b1: return true;
    case 0x28b2: return true;
    case 0x28b3: return true;
    case 0x28b4: return true;
    case 0x28b5: return true;
    case 0x28b6: return true;
    case 0x28b7: return true;
    case 0x28b8: return true;
    case 0x28b9: return true;
    case 0x28ba: return true;
    case 0x28bb: return true;
    case 0x28bc: return true;
    case 0x28bd: return true;
    case 0x28be: return true;
    case 0x28bf: return true;
    case 0x28c0: return true;
    case 0x28c1: return true;
    case 0x28c2: return true;
    case 0x28c3: return true;
    case 0x28c4: return true;
    case 0x28c5: return true;
    case 0x28c6: return true;
    case 0x28c7: return true;
    case 0x28c8: return true;
    case 0x28c9: return true;
    case 0x28ca: return true;
    case 0x28cb: return true;
    case 0x28cc: return true;
    case 0x28cd: return true;
    case 0x28ce: return true;
    case 0x28cf: return true;
    case 0x28d0: return true;
    case 0x28d1: return true;
    case 0x28d2: return true;
    case 0x28d3: return true;
    case 0x28d4: return true;
    case 0x28d5: return true;
    case 0x28d6: return true;
    case 0x28d7: return true;
    case 0x28d8: return true;
    case 0x28d9: return true;
    case 0x28da: return true;
    case 0x28db: return true;
    case 0x28dc: return true;
    case 0x28dd: return true;
    case 0x28de: return true;
    case 0x28df: return true;
    case 0x28e0: return true;
    case 0x28e1: return true;
    case 0x28e2: return true;
    case 0x28e3: return true;
    case 0x28e4: return true;
    case 0x28e5: return true;
    case 0x28e6: return true;
    case 0x28e7: return true;
    case 0x28e8: return true;
    case 0x28e9: return true;
    case 0x28ea: return true;
    case 0x28eb: return true;
    case 0x28ec: return true;
    case 0x28ed: return true;
    case 0x28ee: return true;
    case 0x28ef: return true;
    case 0x28f0: return true;
    case 0x28f1: return true;
    case 0x28f2: return true;
    case 0x28f3: return true;
    case 0x28f4: return true;
    case 0x28f5: return true;
    case 0x28f6: return true;
    case 0x28f7: return true;
    case 0x28f8: return true;
    case 0x28f9: return true;
    case 0x28fa: return true;
    case 0x28fb: return true;
    case 0x28fc: return true;
    case 0x28fd: return true;
    case 0x28fe: return true;
    case 0x28ff: return true;
    case 0x2900: return true;
    case 0x2901: return true;
    case 0x2902: return true;
    case 0x2903: return true;
    case 0x2904: return true;
    case 0x2905: return true;
    case 0x2906: return true;
    case 0x2907: return true;
    case 0x2908: return true;
    case 0x2909: return true;
    case 0x290a: return true;
    case 0x290b: return true;
    case 0x290c: return true;
    case 0x290d: return true;
    case 0x290e: return true;
    case 0x290f: return true;
    case 0x2910: return true;
    case 0x2911: return true;
    case 0x2912: return true;
    case 0x2913: return true;
    case 0x2914: return true;
    case 0x2915: return true;
    case 0x2916: return true;
    case 0x2917: return true;
    case 0x2918: return true;
    case 0x2919: return true;
    case 0x291a: return true;
    case 0x291b: return true;
    case 0x291c: return true;
    case 0x291d: return true;
    case 0x291e: return true;
    case 0x291f: return true;
    case 0x2920: return true;
    case 0x2921: return true;
    case 0x2922: return true;
    case 0x2923: return true;
    case 0x2924: return true;
    case 0x2925: return true;
    case 0x2926: return true;
    case 0x2927: return true;
    case 0x2928: return true;
    case 0x2929: return true;
    case 0x292a: return true;
    case 0x292b: return true;
    case 0x292c: return true;
    case 0x292d: return true;
    case 0x292e: return true;
    case 0x292f: return true;
    case 0x2930: return true;
    case 0x2931: return true;
    case 0x2932: return true;
    case 0x2933: return true;
    case 0x2934: return true;
    case 0x2935: return true;
    case 0x2936: return true;
    case 0x2937: return true;
    case 0x2938: return true;
    case 0x2939: return true;
    case 0x293a: return true;
    case 0x293b: return true;
    case 0x293c: return true;
    case 0x293d: return true;
    case 0x293e: return true;
    case 0x293f: return true;
    case 0x2940: return true;
    case 0x2941: return true;
    case 0x2942: return true;
    case 0x2943: return true;
    case 0x2944: return true;
    case 0x2945: return true;
    case 0x2946: return true;
    case 0x2947: return true;
    case 0x2948: return true;
    case 0x2949: return true;
    case 0x294a: return true;
    case 0x294b: return true;
    case 0x294c: return true;
    case 0x294d: return true;
    case 0x294e: return true;
    case 0x294f: return true;
    case 0x2950: return true;
    case 0x2951: return true;
    case 0x2952: return true;
    case 0x2953: return true;
    case 0x2954: return true;
    case 0x2955: return true;
    case 0x2956: return true;
    case 0x2957: return true;
    case 0x2958: return true;
    case 0x2959: return true;
    case 0x295a: return true;
    case 0x295b: return true;
    case 0x295c: return true;
    case 0x295d: return true;
    case 0x295e: return true;
    case 0x295f: return true;
    case 0x2960: return true;
    case 0x2961: return true;
    case 0x2962: return true;
    case 0x2963: return true;
    case 0x2964: return true;
    case 0x2965: return true;
    case 0x2966: return true;
    case 0x2967: return true;
    case 0x2968: return true;
    case 0x2969: return true;
    case 0x296a: return true;
    case 0x296b: return true;
    case 0x296c: return true;
    case 0x296d: return true;
    case 0x296e: return true;
    case 0x296f: return true;
    case 0x2970: return true;
    case 0x2971: return true;
    case 0x2972: return true;
    case 0x2973: return true;
    case 0x2974: return true;
    case 0x2975: return true;
    case 0x2976: return true;
    case 0x2977: return true;
    case 0x2978: return true;
    case 0x2979: return true;
    case 0x297a: return true;
    case 0x297b: return true;
    case 0x297c: return true;
    case 0x297d: return true;
    case 0x297e: return true;
    case 0x297f: return true;
    case 0x2980: return true;
    case 0x2981: return true;
    case 0x2982: return true;
    case 0x2983: return true;
    case 0x2984: return true;
    case 0x2985: return true;
    case 0x2986: return true;
    case 0x2987: return true;
    case 0x2988: return true;
    case 0x2989: return true;
    case 0x298a: return true;
    case 0x298b: return true;
    case 0x298c: return true;
    case 0x298d: return true;
    case 0x298e: return true;
    case 0x298f: return true;
    case 0x2990: return true;
    case 0x2991: return true;
    case 0x2992: return true;
    case 0x2993: return true;
    case 0x2994: return true;
    case 0x2995: return true;
    case 0x2996: return true;
    case 0x2997: return true;
    case 0x2998: return true;
    case 0x2999: return true;
    case 0x299a: return true;
    case 0x299b: return true;
    case 0x299c: return true;
    case 0x299d: return true;
    case 0x299e: return true;
    case 0x299f: return true;
    case 0x29a0: return true;
    case 0x29a1: return true;
    case 0x29a2: return true;
    case 0x29a3: return true;
    case 0x29a4: return true;
    case 0x29a5: return true;
    case 0x29a6: return true;
    case 0x29a7: return true;
    case 0x29a8: return true;
    case 0x29a9: return true;
    case 0x29aa: return true;
    case 0x29ab: return true;
    case 0x29ac: return true;
    case 0x29ad: return true;
    case 0x29ae: return true;
    case 0x29af: return true;
    case 0x29b0: return true;
    case 0x29b1: return true;
    case 0x29b2: return true;
    case 0x29b3: return true;
    case 0x29b4: return true;
    case 0x29b5: return true;
    case 0x29b6: return true;
    case 0x29b7: return true;
    case 0x29b8: return true;
    case 0x29b9: return true;
    case 0x29ba: return true;
    case 0x29bb: return true;
    case 0x29bc: return true;
    case 0x29bd: return true;
    case 0x29be: return true;
    case 0x29bf: return true;
    case 0x29c0: return true;
    case 0x29c1: return true;
    case 0x29c2: return true;
    case 0x29c3: return true;
    case 0x29c4: return true;
    case 0x29c5: return true;
    case 0x29c6: return true;
    case 0x29c7: return true;
    case 0x29c8: return true;
    case 0x29c9: return true;
    case 0x29ca: return true;
    case 0x29cb: return true;
    case 0x29cc: return true;
    case 0x29cd: return true;
    case 0x29ce: return true;
    case 0x29cf: return true;
    case 0x29d0: return true;
    case 0x29d1: return true;
    case 0x29d2: return true;
    case 0x29d3: return true;
    case 0x29d4: return true;
    case 0x29d5: return true;
    case 0x29d6: return true;
    case 0x29d7: return true;
    case 0x29d8: return true;
    case 0x29d9: return true;
    case 0x29da: return true;
    case 0x29db: return true;
    case 0x29dc: return true;
    case 0x29dd: return true;
    case 0x29de: return true;
    case 0x29df: return true;
    case 0x29e0: return true;
    case 0x29e1: return true;
    case 0x29e2: return true;
    case 0x29e3: return true;
    case 0x29e4: return true;
    case 0x29e5: return true;
    case 0x29e6: return true;
    case 0x29e7: return true;
    case 0x29e8: return true;
    case 0x29e9: return true;
    case 0x29ea: return true;
    case 0x29eb: return true;
    case 0x29ec: return true;
    case 0x29ed: return true;
    case 0x29ee: return true;
    case 0x29ef: return true;
    case 0x29f0: return true;
    case 0x29f1: return true;
    case 0x29f2: return true;
    case 0x29f3: return true;
    case 0x29f4: return true;
    case 0x29f5: return true;
    case 0x29f6: return true;
    case 0x29f7: return true;
    case 0x29f8: return true;
    case 0x29f9: return true;
    case 0x29fa: return true;
    case 0x29fb: return true;
    case 0x29fc: return true;
    case 0x29fd: return true;
    case 0x29fe: return true;
    case 0x29ff: return true;
    case 0x2a00: return true;
    case 0x2a01: return true;
    case 0x2a02: return true;
    case 0x2a03: return true;
    case 0x2a04: return true;
    case 0x2a05: return true;
    case 0x2a06: return true;
    case 0x2a07: return true;
    case 0x2a08: return true;
    case 0x2a09: return true;
    case 0x2a0a: return true;
    case 0x2a0b: return true;
    case 0x2a0c: return true;
    case 0x2a0d: return true;
    case 0x2a0e: return true;
    case 0x2a0f: return true;
    case 0x2a10: return true;
    case 0x2a11: return true;
    case 0x2a12: return true;
    case 0x2a13: return true;
    case 0x2a14: return true;
    case 0x2a15: return true;
    case 0x2a16: return true;
    case 0x2a17: return true;
    case 0x2a18: return true;
    case 0x2a19: return true;
    case 0x2a1a: return true;
    case 0x2a1b: return true;
    case 0x2a1c: return true;
    case 0x2a1d: return true;
    case 0x2a1e: return true;
    case 0x2a1f: return true;
    case 0x2a20: return true;
    case 0x2a21: return true;
    case 0x2a22: return true;
    case 0x2a23: return true;
    case 0x2a24: return true;
    case 0x2a25: return true;
    case 0x2a26: return true;
    case 0x2a27: return true;
    case 0x2a28: return true;
    case 0x2a29: return true;
    case 0x2a2a: return true;
    case 0x2a2b: return true;
    case 0x2a2c: return true;
    case 0x2a2d: return true;
    case 0x2a2e: return true;
    case 0x2a2f: return true;
    case 0x2a30: return true;
    case 0x2a31: return true;
    case 0x2a32: return true;
    case 0x2a33: return true;
    case 0x2a34: return true;
    case 0x2a35: return true;
    case 0x2a36: return true;
    case 0x2a37: return true;
    case 0x2a38: return true;
    case 0x2a39: return true;
    case 0x2a3a: return true;
    case 0x2a3b: return true;
    case 0x2a3c: return true;
    case 0x2a3d: return true;
    case 0x2a3e: return true;
    case 0x2a3f: return true;
    case 0x2a40: return true;
    case 0x2a41: return true;
    case 0x2a42: return true;
    case 0x2a43: return true;
    case 0x2a44: return true;
    case 0x2a45: return true;
    case 0x2a46: return true;
    case 0x2a47: return true;
    case 0x2a48: return true;
    case 0x2a49: return true;
    case 0x2a4a: return true;
    case 0x2a4b: return true;
    case 0x2a4c: return true;
    case 0x2a4d: return true;
    case 0x2a4e: return true;
    case 0x2a4f: return true;
    case 0x2a50: return true;
    case 0x2a51: return true;
    case 0x2a52: return true;
    case 0x2a53: return true;
    case 0x2a54: return true;
    case 0x2a55: return true;
    case 0x2a56: return true;
    case 0x2a57: return true;
    case 0x2a58: return true;
    case 0x2a59: return true;
    case 0x2a5a: return true;
    case 0x2a5b: return true;
    case 0x2a5c: return true;
    case 0x2a5d: return true;
    case 0x2a5e: return true;
    case 0x2a5f: return true;
    case 0x2a60: return true;
    case 0x2a61: return true;
    case 0x2a62: return true;
    case 0x2a63: return true;
    case 0x2a64: return true;
    case 0x2a65: return true;
    case 0x2a66: return true;
    case 0x2a67: return true;
    case 0x2a68: return true;
    case 0x2a69: return true;
    case 0x2a6a: return true;
    case 0x2a6b: return true;
    case 0x2a6c: return true;
    case 0x2a6d: return true;
    case 0x2a6e: return true;
    case 0x2a6f: return true;
    case 0x2a70: return true;
    case 0x2a71: return true;
    case 0x2a72: return true;
    case 0x2a73: return true;
    case 0x2a74: return true;
    case 0x2a75: return true;
    case 0x2a76: return true;
    case 0x2a77: return true;
    case 0x2a78: return true;
    case 0x2a79: return true;
    case 0x2a7a: return true;
    case 0x2a7b: return true;
    case 0x2a7c: return true;
    case 0x2a7d: return true;
    case 0x2a7e: return true;
    case 0x2a7f: return true;
    case 0x2a80: return true;
    case 0x2a81: return true;
    case 0x2a82: return true;
    case 0x2a83: return true;
    case 0x2a84: return true;
    case 0x2a85: return true;
    case 0x2a86: return true;
    case 0x2a87: return true;
    case 0x2a88: return true;
    case 0x2a89: return true;
    case 0x2a8a: return true;
    case 0x2a8b: return true;
    case 0x2a8c: return true;
    case 0x2a8d: return true;
    case 0x2a8e: return true;
    case 0x2a8f: return true;
    case 0x2a90: return true;
    case 0x2a91: return true;
    case 0x2a92: return true;
    case 0x2a93: return true;
    case 0x2a94: return true;
    case 0x2a95: return true;
    case 0x2a96: return true;
    case 0x2a97: return true;
    case 0x2a98: return true;
    case 0x2a99: return true;
    case 0x2a9a: return true;
    case 0x2a9b: return true;
    case 0x2a9c: return true;
    case 0x2a9d: return true;
    case 0x2a9e: return true;
    case 0x2a9f: return true;
    case 0x2aa0: return true;
    case 0x2aa1: return true;
    case 0x2aa2: return true;
    case 0x2aa3: return true;
    case 0x2aa4: return true;
    case 0x2aa5: return true;
    case 0x2aa6: return true;
    case 0x2aa7: return true;
    case 0x2aa8: return true;
    case 0x2aa9: return true;
    case 0x2aaa: return true;
    case 0x2aab: return true;
    case 0x2aac: return true;
    case 0x2aad: return true;
    case 0x2aae: return true;
    case 0x2aaf: return true;
    case 0x2ab0: return true;
    case 0x2ab1: return true;
    case 0x2ab2: return true;
    case 0x2ab3: return true;
    case 0x2ab4: return true;
    case 0x2ab5: return true;
    case 0x2ab6: return true;
    case 0x2ab7: return true;
    case 0x2ab8: return true;
    case 0x2ab9: return true;
    case 0x2aba: return true;
    case 0x2abb: return true;
    case 0x2abc: return true;
    case 0x2abd: return true;
    case 0x2abe: return true;
    case 0x2abf: return true;
    case 0x2ac0: return true;
    case 0x2ac1: return true;
    case 0x2ac2: return true;
    case 0x2ac3: return true;
    case 0x2ac4: return true;
    case 0x2ac5: return true;
    case 0x2ac6: return true;
    case 0x2ac7: return true;
    case 0x2ac8: return true;
    case 0x2ac9: return true;
    case 0x2aca: return true;
    case 0x2acb: return true;
    case 0x2acc: return true;
    case 0x2acd: return true;
    case 0x2ace: return true;
    case 0x2acf: return true;
    case 0x2ad0: return true;
    case 0x2ad1: return true;
    case 0x2ad2: return true;
    case 0x2ad3: return true;
    case 0x2ad4: return true;
    case 0x2ad5: return true;
    case 0x2ad6: return true;
    case 0x2ad7: return true;
    case 0x2ad8: return true;
    case 0x2ad9: return true;
    case 0x2ada: return true;
    case 0x2adb: return true;
    case 0x2adc: return true;
    case 0x2add: return true;
    case 0x2ade: return true;
    case 0x2adf: return true;
    case 0x2ae0: return true;
    case 0x2ae1: return true;
    case 0x2ae2: return true;
    case 0x2ae3: return true;
    case 0x2ae4: return true;
    case 0x2ae5: return true;
    case 0x2ae6: return true;
    case 0x2ae7: return true;
    case 0x2ae8: return true;
    case 0x2ae9: return true;
    case 0x2aea: return true;
    case 0x2aeb: return true;
    case 0x2aec: return true;
    case 0x2aed: return true;
    case 0x2aee: return true;
    case 0x2aef: return true;
    case 0x2af0: return true;
    case 0x2af1: return true;
    case 0x2af2: return true;
    case 0x2af3: return true;
    case 0x2af4: return true;
    case 0x2af5: return true;
    case 0x2af6: return true;
    case 0x2af7: return true;
    case 0x2af8: return true;
    case 0x2af9: return true;
    case 0x2afa: return true;
    case 0x2afb: return true;
    case 0x2afc: return true;
    case 0x2afd: return true;
    case 0x2afe: return true;
    case 0x2aff: return true;
    case 0x2b00: return true;
    case 0x2b01: return true;
    case 0x2b02: return true;
    case 0x2b03: return true;
    case 0x2b04: return true;
    case 0x2b05: return true;
    case 0x2b06: return true;
    case 0x2b07: return true;
    case 0x2b08: return true;
    case 0x2b09: return true;
    case 0x2b0a: return true;
    case 0x2b0b: return true;
    case 0x2b0c: return true;
    case 0x2b0d: return true;
    case 0x2b0e: return true;
    case 0x2b0f: return true;
    case 0x2b10: return true;
    case 0x2b11: return true;
    case 0x2b12: return true;
    case 0x2b13: return true;
    case 0x2b14: return true;
    case 0x2b15: return true;
    case 0x2b16: return true;
    case 0x2b17: return true;
    case 0x2b18: return true;
    case 0x2b19: return true;
    case 0x2b1a: return true;
    case 0x2b1b: return true;
    case 0x2b1c: return true;
    case 0x2b1d: return true;
    case 0x2b1e: return true;
    case 0x2b1f: return true;
    case 0x2b20: return true;
    case 0x2b21: return true;
    case 0x2b22: return true;
    case 0x2b23: return true;
    case 0x2b24: return true;
    case 0x2b25: return true;
    case 0x2b26: return true;
    case 0x2b27: return true;
    case 0x2b28: return true;
    case 0x2b29: return true;
    case 0x2b2a: return true;
    case 0x2b2b: return true;
    case 0x2b2c: return true;
    case 0x2b2d: return true;
    case 0x2b2e: return true;
    case 0x2b2f: return true;
    case 0x2b30: return true;
    case 0x2b31: return true;
    case 0x2b32: return true;
    case 0x2b33: return true;
    case 0x2b34: return true;
    case 0x2b35: return true;
    case 0x2b36: return true;
    case 0x2b37: return true;
    case 0x2b38: return true;
    case 0x2b39: return true;
    case 0x2b3a: return true;
    case 0x2b3b: return true;
    case 0x2b3c: return true;
    case 0x2b3d: return true;
    case 0x2b3e: return true;
    case 0x2b3f: return true;
    case 0x2b40: return true;
    case 0x2b41: return true;
    case 0x2b42: return true;
    case 0x2b43: return true;
    case 0x2b44: return true;
    case 0x2b45: return true;
    case 0x2b46: return true;
    case 0x2b47: return true;
    case 0x2b48: return true;
    case 0x2b49: return true;
    case 0x2b4a: return true;
    case 0x2b4b: return true;
    case 0x2b4c: return true;
    case 0x2b4d: return true;
    case 0x2b4e: return true;
    case 0x2b4f: return true;
    case 0x2b50: return true;
    case 0x2b51: return true;
    case 0x2b52: return true;
    case 0x2b53: return true;
    case 0x2b54: return true;
    case 0x2b55: return true;
    case 0x2b56: return true;
    case 0x2b57: return true;
    case 0x2b58: return true;
    case 0x2b59: return true;
    case 0x2b5a: return true;
    case 0x2b5b: return true;
    case 0x2b5c: return true;
    case 0x2b5d: return true;
    case 0x2b5e: return true;
    case 0x2b5f: return true;
    case 0x2b60: return true;
    case 0x2b61: return true;
    case 0x2b62: return true;
    case 0x2b63: return true;
    case 0x2b64: return true;
    case 0x2b65: return true;
    case 0x2b66: return true;
    case 0x2b67: return true;
    case 0x2b68: return true;
    case 0x2b69: return true;
    case 0x2b6a: return true;
    case 0x2b6b: return true;
    case 0x2b6c: return true;
    case 0x2b6d: return true;
    case 0x2b6e: return true;
    case 0x2b6f: return true;
    case 0x2b70: return true;
    case 0x2b71: return true;
    case 0x2b72: return true;
    case 0x2b73: return true;
    case 0x2b74: return true;
    case 0x2b75: return true;
    case 0x2b76: return true;
    case 0x2b77: return true;
    case 0x2b78: return true;
    case 0x2b79: return true;
    case 0x2b7a: return true;
    case 0x2b7b: return true;
    case 0x2b7c: return true;
    case 0x2b7d: return true;
    case 0x2b7e: return true;
    case 0x2b7f: return true;
    case 0x2b80: return true;
    case 0x2b81: return true;
    case 0x2b82: return true;
    case 0x2b83: return true;
    case 0x2b84: return true;
    case 0x2b85: return true;
    case 0x2b86: return true;
    case 0x2b87: return true;
    case 0x2b88: return true;
    case 0x2b89: return true;
    case 0x2b8a: return true;
    case 0x2b8b: return true;
    case 0x2b8c: return true;
    case 0x2b8d: return true;
    case 0x2b8e: return true;
    case 0x2b8f: return true;
    case 0x2b90: return true;
    case 0x2b91: return true;
    case 0x2b92: return true;
    case 0x2b93: return true;
    case 0x2b94: return true;
    case 0x2b95: return true;
    case 0x2b96: return true;
    case 0x2b97: return true;
    case 0x2b98: return true;
    case 0x2b99: return true;
    case 0x2b9a: return true;
    case 0x2b9b: return true;
    case 0x2b9c: return true;
    case 0x2b9d: return true;
    case 0x2b9e: return true;
    case 0x2b9f: return true;
    case 0x2ba0: return true;
    case 0x2ba1: return true;
    case 0x2ba2: return true;
    case 0x2ba3: return true;
    case 0x2ba4: return true;
    case 0x2ba5: return true;
    case 0x2ba6: return true;
    case 0x2ba7: return true;
    case 0x2ba8: return true;
    case 0x2ba9: return true;
    case 0x2baa: return true;
    case 0x2bab: return true;
    case 0x2bac: return true;
    case 0x2bad: return true;
    case 0x2bae: return true;
    case 0x2baf: return true;
    case 0x2bb0: return true;
    case 0x2bb1: return true;
    case 0x2bb2: return true;
    case 0x2bb3: return true;
    case 0x2bb4: return true;
    case 0x2bb5: return true;
    case 0x2bb6: return true;
    case 0x2bb7: return true;
    case 0x2bb8: return true;
    case 0x2bb9: return true;
    case 0x2bba: return true;
    case 0x2bbb: return true;
    case 0x2bbc: return true;
    case 0x2bbd: return true;
    case 0x2bbe: return true;
    case 0x2bbf: return true;
    case 0x2bc0: return true;
    case 0x2bc1: return true;
    case 0x2bc2: return true;
    case 0x2bc3: return true;
    case 0x2bc4: return true;
    case 0x2bc5: return true;
    case 0x2bc6: return true;
    case 0x2bc7: return true;
    case 0x2bc8: return true;
    case 0x2bc9: return true;
    case 0x2bca: return true;
    case 0x2bcb: return true;
    case 0x2bcc: return true;
    case 0x2bcd: return true;
    case 0x2bce: return true;
    case 0x2bcf: return true;
    case 0x2bd0: return true;
    case 0x2bd1: return true;
    case 0x2bd2: return true;
    case 0x2bd3: return true;
    case 0x2bd4: return true;
    case 0x2bd5: return true;
    case 0x2bd6: return true;
    case 0x2bd7: return true;
    case 0x2bd8: return true;
    case 0x2bd9: return true;
    case 0x2bda: return true;
    case 0x2bdb: return true;
    case 0x2bdc: return true;
    case 0x2bdd: return true;
    case 0x2bde: return true;
    case 0x2bdf: return true;
    case 0x2be0: return true;
    case 0x2be1: return true;
    case 0x2be2: return true;
    case 0x2be3: return true;
    case 0x2be4: return true;
    case 0x2be5: return true;
    case 0x2be6: return true;
    case 0x2be7: return true;
    case 0x2be8: return true;
    case 0x2be9: return true;
    case 0x2bea: return true;
    case 0x2beb: return true;
    case 0x2bec: return true;
    case 0x2bed: return true;
    case 0x2bee: return true;
    case 0x2bef: return true;
    case 0x2bf0: return true;
    case 0x2bf1: return true;
    case 0x2bf2: return true;
    case 0x2bf3: return true;
    case 0x2bf4: return true;
    case 0x2bf5: return true;
    case 0x2bf6: return true;
    case 0x2bf7: return true;
    case 0x2bf8: return true;
    case 0x2bf9: return true;
    case 0x2bfa: return true;
    case 0x2bfb: return true;
    case 0x2bfc: return true;
    case 0x2bfd: return true;
    case 0x2bfe: return true;
    case 0x2bff: return true;
    case 0x2e00: return true;
    case 0x2e01: return true;
    case 0x2e02: return true;
    case 0x2e03: return true;
    case 0x2e04: return true;
    case 0x2e05: return true;
    case 0x2e06: return true;
    case 0x2e07: return true;
    case 0x2e08: return true;
    case 0x2e09: return true;
    case 0x2e0a: return true;
    case 0x2e0b: return true;
    case 0x2e0c: return true;
    case 0x2e0d: return true;
    case 0x2e0e: return true;
    case 0x2e0f: return true;
    case 0x2e10: return true;
    case 0x2e11: return true;
    case 0x2e12: return true;
    case 0x2e13: return true;
    case 0x2e14: return true;
    case 0x2e15: return true;
    case 0x2e16: return true;
    case 0x2e17: return true;
    case 0x2e18: return true;
    case 0x2e19: return true;
    case 0x2e1a: return true;
    case 0x2e1b: return true;
    case 0x2e1c: return true;
    case 0x2e1d: return true;
    case 0x2e1e: return true;
    case 0x2e1f: return true;
    case 0x2e20: return true;
    case 0x2e21: return true;
    case 0x2e22: return true;
    case 0x2e23: return true;
    case 0x2e24: return true;
    case 0x2e25: return true;
    case 0x2e26: return true;
    case 0x2e27: return true;
    case 0x2e28: return true;
    case 0x2e29: return true;
    case 0x2e2a: return true;
    case 0x2e2b: return true;
    case 0x2e2c: return true;
    case 0x2e2d: return true;
    case 0x2e2e: return true;
    case 0x2e2f: return true;
    case 0x2e30: return true;
    case 0x2e31: return true;
    case 0x2e32: return true;
    case 0x2e33: return true;
    case 0x2e34: return true;
    case 0x2e35: return true;
    case 0x2e36: return true;
    case 0x2e37: return true;
    case 0x2e38: return true;
    case 0x2e39: return true;
    case 0x2e3a: return true;
    case 0x2e3b: return true;
    case 0x2e3c: return true;
    case 0x2e3d: return true;
    case 0x2e3e: return true;
    case 0x2e3f: return true;
    case 0x2e40: return true;
    case 0x2e41: return true;
    case 0x2e42: return true;
    case 0x2e43: return true;
    case 0x2e44: return true;
    case 0x2e45: return true;
    case 0x2e46: return true;
    case 0x2e47: return true;
    case 0x2e48: return true;
    case 0x2e49: return true;
    case 0x2e4a: return true;
    case 0x2e4b: return true;
    case 0x2e4c: return true;
    case 0x2e4d: return true;
    case 0x2e4e: return true;
    case 0x2e4f: return true;
    case 0x2e50: return true;
    case 0x2e51: return true;
    case 0x2e52: return true;
    case 0x2e53: return true;
    case 0x2e54: return true;
    case 0x2e55: return true;
    case 0x2e56: return true;
    case 0x2e57: return true;
    case 0x2e58: return true;
    case 0x2e59: return true;
    case 0x2e5a: return true;
    case 0x2e5b: return true;
    case 0x2e5c: return true;
    case 0x2e5d: return true;
    case 0x2e5e: return true;
    case 0x2e5f: return true;
    case 0x2e60: return true;
    case 0x2e61: return true;
    case 0x2e62: return true;
    case 0x2e63: return true;
    case 0x2e64: return true;
    case 0x2e65: return true;
    case 0x2e66: return true;
    case 0x2e67: return true;
    case 0x2e68: return true;
    case 0x2e69: return true;
    case 0x2e6a: return true;
    case 0x2e6b: return true;
    case 0x2e6c: return true;
    case 0x2e6d: return true;
    case 0x2e6e: return true;
    case 0x2e6f: return true;
    case 0x2e70: return true;
    case 0x2e71: return true;
    case 0x2e72: return true;
    case 0x2e73: return true;
    case 0x2e74: return true;
    case 0x2e75: return true;
    case 0x2e76: return true;
    case 0x2e77: return true;
    case 0x2e78: return true;
    case 0x2e79: return true;
    case 0x2e7a: return true;
    case 0x2e7b: return true;
    case 0x2e7c: return true;
    case 0x2e7d: return true;
    case 0x2e7e: return true;
    case 0x2e7f: return true;
    case 0x3000: return true;
    case 0x3001: return true;
    case 0x3002: return true;
    case 0x3003: return true;
    case 0x3008: return true;
    case 0x3009: return true;
    case 0x300a: return true;
    case 0x300b: return true;
    case 0x300c: return true;
    case 0x300d: return true;
    case 0x300e: return true;
    case 0x300f: return true;
    case 0x3010: return true;
    case 0x3011: return true;
    case 0x3012: return true;
    case 0x3013: return true;
    case 0x3014: return true;
    case 0x3015: return true;
    case 0x3016: return true;
    case 0x3017: return true;
    case 0x3018: return true;
    case 0x3019: return true;
    case 0x301a: return true;
    case 0x301b: return true;
    case 0x301c: return true;
    case 0x301d: return true;
    case 0x301e: return true;
    case 0x301f: return true;
    case 0x3020: return true;
    case 0x3030: return true;
    case 0x30a0: return true;
    case 0x30fb: return true;
    case 0xa4fe: return true;
    case 0xa4ff: return true;
    case 0xa60d: return true;
    case 0xa60e: return true;
    case 0xa60f: return true;
    case 0xa6f3: return true;
    case 0xa6f4: return true;
    case 0xa6f5: return true;
    case 0xa6f6: return true;
    case 0xa6f7: return true;
    case 0xa876: return true;
    case 0xa877: return true;
    case 0xa8ce: return true;
    case 0xa8cf: return true;
    case 0xa92f: return true;
    case 0xa9c7: return true;
    case 0xa9c8: return true;
    case 0xa9c9: return true;
    case 0xaa5d: return true;
    case 0xaa5e: return true;
    case 0xaa5f: return true;
    case 0xaadf: return true;
    case 0xaaf0: return true;
    case 0xaaf1: return true;
    case 0xabeb: return true;
    case 0xfd3e: return true;
    case 0xfd3f: return true;
    case 0xfe31: return true;
    case 0xfe32: return true;
    case 0xfe41: return true;
    case 0xfe42: return true;
    case 0xfe43: return true;
    case 0xfe44: return true;
    case 0xfe45: return true;
    case 0xfe46: return true;
    case 0xfe50: return true;
    case 0xfe51: return true;
    case 0xfe52: return true;
    case 0xfe54: return true;
    case 0xfe55: return true;
    case 0xfe56: return true;
    case 0xfe57: return true;
    case 0xfe58: return true;
    case 0xfe63: return true;
    case 0xff01: return true;
    case 0xff02: return true;
    case 0xff07: return true;
    case 0xff0c: return true;
    case 0xff0d: return true;
    case 0xff0e: return true;
    case 0xff1a: return true;
    case 0xff1b: return true;
    case 0xff1f: return true;
    case 0xff61: return true;
    case 0xff62: return true;
    case 0xff63: return true;
    case 0xff64: return true;
    case 0xff65: return true;
    case 0x1039f: return true;
    case 0x103d0: return true;
    case 0x10857: return true;
    case 0x1091f: return true;
    case 0x10a56: return true;
    case 0x10a57: return true;
    case 0x10af0: return true;
    case 0x10af1: return true;
    case 0x10af2: return true;
    case 0x10af3: return true;
    case 0x10af4: return true;
    case 0x10af5: return true;
    case 0x10b3a: return true;
    case 0x10b3b: return true;
    case 0x10b3c: return true;
    case 0x10b3d: return true;
    case 0x10b3e: return true;
    case 0x10b3f: return true;
    case 0x10b99: return true;
    case 0x10b9a: return true;
    case 0x10b9b: return true;
    case 0x10b9c: return true;
    case 0x11047: return true;
    case 0x11048: return true;
    case 0x11049: return true;
    case 0x1104a: return true;
    case 0x1104b: return true;
    case 0x1104c: return true;
    case 0x1104d: return true;
    case 0x110be: return true;
    case 0x110bf: return true;
    case 0x110c0: return true;
    case 0x110c1: return true;
    case 0x11141: return true;
    case 0x11142: return true;
    case 0x11143: return true;
    case 0x111c5: return true;
    case 0x111c6: return true;
    case 0x111cd: return true;
    case 0x111de: return true;
    case 0x111df: return true;
    case 0x11238: return true;
    case 0x11239: return true;
    case 0x1123a: return true;
    case 0x1123b: return true;
    case 0x1123c: return true;
    case 0x112a9: return true;
    case 0x115c2: return true;
    case 0x115c3: return true;
    case 0x115c4: return true;
    case 0x115c5: return true;
    case 0x115c9: return true;
    case 0x115ca: return true;
    case 0x115cb: return true;
    case 0x115cc: return true;
    case 0x115cd: return true;
    case 0x115ce: return true;
    case 0x115cf: return true;
    case 0x115d0: return true;
    case 0x115d1: return true;
    case 0x115d2: return true;
    case 0x115d3: return true;
    case 0x115d4: return true;
    case 0x115d5: return true;
    case 0x115d6: return true;
    case 0x115d7: return true;
    case 0x11641: return true;
    case 0x11642: return true;
    case 0x1173c: return true;
    case 0x1173d: return true;
    case 0x1173e: return true;
    case 0x12470: return true;
    case 0x12471: return true;
    case 0x12472: return true;
    case 0x12473: return true;
    case 0x12474: return true;
    case 0x16a6e: return true;
    case 0x16a6f: return true;
    case 0x16af5: return true;
    case 0x16b37: return true;
    case 0x16b38: return true;
    case 0x16b39: return true;
    case 0x16b44: return true;
    case 0x1bc9f: return true;
    case 0x1da87: return true;
    case 0x1da88: return true;
    case 0x1da89: return true;
    case 0x1da8a: return true;
    default: return false;
    }
}
} //  namespace unicode
} //  namespace mongo
